#include "viewHtml.ch"
  
FUNCTION GetLinkFiles( cWWWFile)
   LOCAL aFilesToDownload := {}, aName
   aName := {}
   //cWWWFile := Getfile ( { {'HTML','*.html'},{'HTM','*.htm'} },'Select html file' , '.', .f. , .t. )
   if hb_FileExists( cWWWFile)
      cWWW := memoread(cWWWFile )
   else
      return( aFilesToDownload)
   endif
   if cWWW  == NIL
      msgstop("Something wrong with "+cWWWFile + " file")
      // return .f.
      return( aFilesToDownload)
   endif
   TokenInit( @cWWW, "<>")
   do while .not. TokenEnd()
      cLink := ''
      cTag  := alltrim( TokenNext( cWWW))
      if hmg_lower( cTag) = "link"
         cLink := StripTag( cTag, "href")
         cName := StripTag( cTag, "title")
      elseif hmg_lower( cTag) = "script"
         cLink := StripTag( cTag, "src")
         cName := ''
      elseif hmg_lower(cTag) = "img"
         cLink := StripTag( cTag, "src")
         cName := StripTag( cTag, "alt")
      // elseif hmg_lower(cTag) = "a"
      //    cClass := StripTag( "class")
      //    if cClass == "topictitle" && unread
      //     cLink := StripTag( "href")
      //    endif
      endif
      if !empty(cLink)
         aAdd(aFilesToDownload, cLink)
         aAdd( aName, cName)
         // Main.Grid_Links.AddItem({cLink})
         // msgDebug( cLink)
      endif
   enddo
  return( aFilesToDownload)
  
FUNCTION LocalLink( cLink, cLocalFolder)
  LOCAL cNLink
  DO CASE
    CASE LEFT( cLink, 2) == "./"
      cNLink := ZSLASH + cLocalFolder + SUBSTR( cLink, 2)
    CASE LEFT( cLink, 1) == "/"
      cNLink := ZSLASH + cLocalFolder + cLink
    OTHERWISE
      cNLink := cLink
  ENDCASE
  RETURN( cNLink)  
   
*-------------------
function StripTag
   param cTag, cKeyword
   local i
   local cLink
   
   i := hb_at(cKeyword, hmg_lower(cTag))
   if i > 0
      // cut path and filename
      cTag := substr(cTag,i)
      i := hb_at('"', cTag)
      cTag := substr(cTag,i+1)
      i := hb_at('"', cTag)
      cLink := left(cTag,i-1)
   endif
return cLink

*----------------------
FUNCTION OpenUrl( cUrl, cZipFile)
  // ic_view( cUrl)
  oHttp := TIpClientHttp():new( cUrl )
   if .not. oHttp:open()
      MsgInfo("Connection error:", oHttp:lastErrorMessage())
      Return Nil
   endif
   // read
   cHtml := oHttp:readAll()
   IF EMPTY( cHtml)
     MsgInfo( "Page not loaded !")
     RETURN NIL
   else
     hb_memowrit( cZipFile, cHtml)
     // fDebug( "sukses open ", cUrl, cZipFile)   
     // ic_view( cHtml)
   ENDIF
  RETURN NIL
  
Function mol_SaveURL( cUrl, sDate)
   local oHttp, cHtml, oDoc && , cUrl:=alltrim(Main.Text_1.Value)
   local i
   local cBaseAddress := ''
   local cLocalFolderName
   LOCAL aFilesToDownload
   MEMVAR _HMG_SYSDATA
   DECLARE WINDOW Main
   HB_DEFAULT( @sDate, '')
   // private aFilesToDownload := {}
   // cUrl := STRTRAN( cUrl, ZHTM_AND, ZAMP)
   cUrl := HtmlToANSI( cUrl)
   // connecting
   fdebug( cUrl)
   oHttp := TIpClientHttp():new( cUrl )
   if .not. oHttp:open()
      MsgInfo("Connection error:", oHttp:lastErrorMessage())
      Return Nil
   endif
   // read
   cHtml := oHttp:readAll()
   IF EMPTY( cHtml)
     MsgInfo( "Page not loaded !")
     RETURN NIL
   ENDIF
   // get info
   cTitle := GetHF_Title( cHtml)
   nAt    := AT( " - Page", cTitle)
   IF nAt > 0
     cTitle := LEFT( cTitle, nAt - 1)
   ENDIF
   nActiPage   := VAL( GetHF_ActiPage( cHtml))
   nActiPage   := IIF( nActiPage == 0, 1, nActiPage)
   cNextLink   := GetHF_NextLink( cHtml)
   IF nActiPage == 1
     sDate     := GetHF_FirstPostDate( cHtml)
     // RETURN( FullNextLink( cUrl, cNextLink))
   ENDIF
   oHttp:close()
   // create html object
   oDoc := THtmlDocument():new( cHtml )
   // create folder for saving files
   // cLocalFolderName := dtos(date())+strtran(time(),":","")
   // htmfolder
   cActiPage        := PADL( nActiPage, 2, ZZERO)
   cTitle           := sDate + ZUNDERLINE + cTitle
   cHtmFolderName   := ZHF_DIR + cTitle && + "_page_+ cActiPage && cDir
   CreateFolder( cHtmFolderName)
   // htm name
   cHtmName  := cTitle + "_page_" + cActiPage + ZHTM_EXT
   cHtmName  := CheckFileName( cHtmName)
   cSavedHtm := cHtmFolderName + ZBSLASH + cHtmName
   // tmp disable IF FILE( cSavedHtm)
   // tmp disable   cNextLink := FullNextLink( cUrl, cNextLink)
   // tmp disable   Return( { sDate, cNextLink})151
   
   // tmp disable ENDIF
   oDoc:writeFile( cSavedHtm) && "main.html" )
   // base url address
   i := rat( ZSLASH, cUrl)
   IF i > 0
    cBaseAddress := left(cUrl,i)
   ELSE
    cBaseAddress := cUrl + ZSLASH
   ENDIF
   // get link _files
   // aFilesToDownload := GetLinkFiles( cSavedHtm) && "main.html" )
   aFilesToDownload := {}
   // create folders for _files
   cHtml := HB_MEMOREAD( cSavedHtm)
   aDl   := {}
   aNDL  := { "Not DL!"}
   // folder for _files
   cHtmFolder_files := STRTRAN( cSavedHtm, ZHTM_EXT, "_files")
   CreateFolder( cHtmFolder_files)
   // download attach zip files
   aPost     := GetHF_PostLink( cHtml)
   aPostLink := aPost[ 1]
   aPostFile := aPost[ 2]
   IF .NOT. EMPTY( aPostLink)
     FOR nPL := 1 TO LEN( aPostLink)
       cPostLink := ALLTRIM( aPostLink[ nPL])
       IF EMPTY( cPostLink)
         LOOP
       ENDIF
       DO CASE
        CASE LEFT( cPostLink, 1) == ZDOT .OR. LEFT( cPostLink, 2) == "//"
          cPostLink := cBaseAddress + SUBSTR( cPostLink, 3)
        CASE LEFT( cPostLink, 1) == ZSLASH
          cPostLink := cBaseAddress + SUBSTR( cPostLink, 2)  
        OTHERWISE
         cPostLink := cBaseAddress + cPostLink
       ENDCASE
       cPostFile := ALLTRIM( aPostFile[ nPL])
       // fDebug( cBaseAddress, cPostLink, aPostLInk)
       cPostLink := STRTRAN( cPostLink, "&amp;", "&")
       OpenUrl( cPostLink, cHtmFolder_files + ZBSLASH + cPostFile)
     NEXT
   ENDIF
   //
   cMain_Edit_1_Value := ''
   Main.Edit_1.Value  :=  cSavedHtm
   for i := 1 to len( aFilesToDownload)
     cFilesToDownload := aFilesToDownload[i]  
     // "./download/file.php?id=7999&amp;sid=189136a475b303908acb4447743e61bf"
      if cFilesToDownload = "http"
         // external links http://www.hmgforum.com/app.php/portal
         cDL_Url      := cFilesToDownload
         cDL_FileName := cHtmFolderName + ZBSLASH + CheckFileName( cDL_Url)
      else
        DO CASE
          CASE LEFT( cFilesToDownload, 2) == "//"
            cDL_Url := SUBSTR( cFilesToDownload, 3)
            cDL_Hdd := SUBSTR( cFilesToDownload, 3)
          CASE LEFT( cFilesToDownload, 2) == "./"
            cDL_Url := SUBSTR( cFilesToDownload, 3)
            cDL_Hdd := SUBSTR( cFilesToDownload, 3)
          CASE LEFT( cFilesToDownload, 1) == "/"
            cDL_Url := SUBSTR( cFilesToDownload, 2)
            cDL_Hdd := SUBSTR( cFilesToDownload, 2) 
          OTHERWISE
            cDL_Url := cFilesToDownload
            cDL_Hdd := cFilesToDownload
        ENDCASE
        cDL_Hdd_Htm := cDL_Hdd
        cDL_Url     := cBaseAddress + cDL_Url
        cDL_Hdd     := cHtmFolder_files + ZBSLASH + cDL_Hdd
        //
         cHddFileName  := cFilesToDownload
         cNewFolderName := ""
         // create local nested folders
         // cFToDL_files := cTitle + "\" + cHtmBaseLink
         // // STRTRAN( cSavedHtm, ZHTM_EXT, "_files")
         // CreateFolder( cFToDL_files)
         do while .t.
            n := at( ZSLASH, cHddFileName)
            if n > 0
              // sub dir exist, create dir
               cNewFolderName += left( cHddFileName, n-1)
               CreateFolder( cHtmFolder_files + ZBSLASH + cNewFolderName )
               cNewFolderName += ZBSLASH
               cHddFileName := substr( cHddFileName, n+1)
            else
              // no sub dir anymore
               exit
            endif
         enddo
         cF               := strtran( cDL_Hdd, ZSLASH, ZBSLASH)
         cF               := strtran( cF, '?', "_q_")
         cFullHddFileName := cF && cHtmFolder_files + cF
      endif
      IF .NOT. DownloadFromWWW( cDL_Url, cFullHddFileName, .T.)
        AADD( aNDL, cFullHddFileName)
      ELSE
        // fDebug( cLocalFileName)
        cHtmLink := cHtmFolder_files + cFilesToDownLoad
        cFtDL_Hdd := strtran( cDL_Hdd_Htm, ZSLASH, ZBSLASH)
        cFtDL_Hdd := strtran( cFtDL_Hdd, '?', "_q_")
        cFtDL_Hdd := STRTRAN( cHtmName, ZHTM_EXT, "_files\") + cFtDL_Hdd
        cHtml    := STRTRAN( cHtml, cFilesToDownLoad, cFtDL_Hdd)
        cDL      := cFilesToDownLoad + " -> " + cFtDL_Hdd
        AADD( aDL, cDL)
        cMain_Edit_1_Value := cDL + ZEOL + cMain_Edit_1_Value
        Main.Edit_1.Value  := cMain_Edit_1_Value
      ENDIF
      // Main.Grid_Links.AddItem({cFileName + " ---> "+cLocalFileName})
      DO Events
   next i
   cSavedHtm2 := cHtmFolderName + "\" + cHtmName
   // cSaveHtm2 := sDate + ZUNDERLINE + cSavedHtm
   HB_MEMOWRIT( cSaveDHtm2, cHtml)
   // Main.Grid_Links.AddItem({"Finished!"})
   // ic_view( aDL)
   // MsgInfo( cSaveDHtm2 + " Downloaded and saved in folder: "+ cHtmFolder_files)
  cNextLink := FullNextLink( cUrl, cNextLink)
  fDebug( cSavedHtm, cTitle, cNextLink)
   
  Return( { sDate, cNextLink})
  
FUNCTION FullNextLink( cUrl, cNextLink)
  nRat := RAT( ZSLASH, cUrl)
  cBaseUrl := ''
  IF nRat > 0
    cBaseUrl := LEFT( cUrl, nRat-1)
  ENDIF
  cNextLink := SUBSTR( cNextLink, 2, LEN( cNextLink) - 2)
  IF LEFT( cNextLink, 1) == ZDOT
    cNextLink := cBaseUrl + SUBSTR( cNextLink, 2)
  ENDIF  
  RETURN( cNextLink)
*-----------------------

PROCEDURE DownloadFromWWW
   param cURL, cLocalFileName, lSilent
   LOCAL oCon, oUrl, i, cResponse
   local ret := .f.
   local OldErrorHandler
   
   OldErrorHandler := ErrorBlock({|e| break(e)})
   
   BEGIN SEQUENCE
   cLocalFileName := alltrim(cLocalFileName)
   if lSilent = NIL
      lSilent := .f.
   endif
   oUrl := tURL():New( cUrl )
   IF Empty( oUrl )
      if !lSilent
         MsgBox("Bad url " + cUrl)
      endif
      BREAK
   ENDIF

   IF oUrl:cProto != "http"
      if !lSilent
         MsgBox('Bad url')
      endif
      BREAK
   END
   
   oCon := TipClientHttp():New( oUrl )
   oCon:nConnTimeout := 20000
   if !lSilent
      // MsgBox("Connecting with "+ oUrl:cServer)
      WaitWindow( "Connecting with "+ oUrl:cServer, .T.)
   endif
   IF oCon:Open( cUrl )
      if !lSilent
         // MsgBox("Connection established." +chr(10)+"Press OK to download " + oUrl:cPath +oUrl:cFile)
         WaitWindow( "Connection established." +chr(10)+"Press OK to download " + oUrl:cPath +oUrl:cFile)
      endif
      oCon:WriteAll(cLocalFileName)
      if !lSilent
         // MsgBox("Downloaded as: "+cLocalFileName)
         WaitWindow( "Downloaded as: "+cLocalFileName)
      endif
      oCon:Close()
      ret := .t.
   ELSE
      IF oCon:SocketCon == NIL
         cResponse := "Connection not initialized"
      ELSEIF hb_InetErrorCode( oCon:SocketCon ) == 0
         cResponse := oCon:cReply
      ELSE
         if !lSilent
            cResponse := "Error in connection: " + hb_InetErrorDesc( oCon:SocketCon )
         endif
      ENDIF
      if !lSilent
         MsgBox("I can not connect to: "+ oUrl:cServer+chr(10)+"Server response: "+cResponse)
      endif
      ret := .f.
   END
   RECOVER
      if !lSilent
         MSGSTOP("Unknown error")
      endif
   END SEQUENCE
   ErrorBlock(OldErrorHandler)
RETURN ret
